diff --git a/src/main/java/net/minecraft/core/world/World.java b/src/main/java/net/minecraft/core/world/World.java
index 56552794e..73f856909 100644
--- a/src/main/java/net/minecraft/core/world/World.java
+++ b/src/main/java/net/minecraft/core/world/World.java
@@ -1,8 +1,22 @@
 package net.minecraft.core.world;
 
+import static net.minecraft.core.Global.*;
+
+import java.util.ArrayList;
+import java.util.Collection;
+import java.util.HashSet;
+import java.util.Iterator;
+import java.util.LinkedList;
+import java.util.List;
+import java.util.Random;
+import java.util.Set;
+import java.util.TreeSet;
+
 import com.mojang.nbt.CompoundTag;
+
 import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.camera.ICamera;
+import net.minecraft.client.render.colorizer.Colorizers;
 import net.minecraft.client.world.chunk.provider.ChunkProviderViewer;
 import net.minecraft.core.Global;
 import net.minecraft.core.HitResult;
@@ -54,19 +68,6 @@ import net.minecraft.core.world.type.WorldTypes;
 import net.minecraft.core.world.weather.Weather;
 import net.minecraft.core.world.weather.WeatherManager;
 
-import java.util.ArrayList;
-import java.util.Collection;
-import java.util.HashSet;
-import java.util.Iterator;
-import java.util.LinkedList;
-import java.util.List;
-import java.util.Random;
-import java.util.Set;
-import java.util.TreeSet;
-
-import static net.minecraft.core.Global.DAY_LENGTH_TICKS;
-import static net.minecraft.core.Global.accessor;
-
 public class World implements WorldSource {
 
     public static boolean AUTOSAVE = true;
@@ -89,7 +90,7 @@ public class World implements WorldSource {
     private final Set<NextTickListEntry> immediatelyUpdatedPositions = new HashSet<>();
     
     public boolean scheduledUpdatesAreImmediate = false;
-    private long dimensionColor = 0xffffffL;
+    private int dimensionColor = 0xffffff;
     public int skyDarken = 0;
     protected int updateLCG = new Random().nextInt();
     public int lightningFlicker = 0;
@@ -117,8 +118,8 @@ public class World implements WorldSource {
     public boolean isClientSide = false;
     public int sleepPercent = 100;
     private long runtime = 0;
-    public boolean updateAllOnLightChange = false;
-
+    public int dayCountLastTick;
+    
     private final BiomeProvider biomeProvider;
 
     public AuroraProvider auroraProvider;
@@ -1604,7 +1605,12 @@ public class World implements WorldSource {
         {
             blockTemperature = blockTemperature - (1.25f);
         }
-        int skyColor = getBiomeProvider().getBiome(x, y, z).getSkyColor(blockTemperature);
+        int skyColor;
+        if(Colorizers.sky.isEnabled()) {
+        	skyColor = Colorizers.sky.getColor(this, x, y, z);
+        }else {
+        	skyColor = getBiomeProvider().getBiome(x, y, z).getSkyColor(blockTemperature);	
+        }
         float r = (float)(skyColor >> 16 & 0xff) / 255F;
         float g = (float)(skyColor >> 8 & 0xff) / 255F;
         float b = (float)(skyColor & 0xff) / 255F;
@@ -1637,10 +1643,13 @@ public class World implements WorldSource {
 
     public float getCelestialAngle(float partialTick)
     {
+    	if(!getGameRule(GameRules.DO_DAY_CYCLE)) {
+    		partialTick = 1.0f;
+    	}
         return worldType.getCelestialAngle(this, levelData.getWorldTime(), partialTick);
     }
 
-    public Vec3d getDimensionColor(float partialTick)
+    public Vec3d getDimensionColor(ICamera camera, float partialTick)
     {
         float f1 = getCelestialAngle(partialTick);
         float f2 = MathHelper.cos(f1 * 3.141593F * 2.0F) * 2.0F + 0.5F;
@@ -1652,26 +1661,30 @@ public class World implements WorldSource {
         {
             f2 = 1.0F;
         }
-        float f3 = (float)(dimensionColor >> 16 & 255L) / 255F;
-        float f4 = (float)(dimensionColor >> 8 & 255L) / 255F;
-        float f5 = (float)(dimensionColor & 255L) / 255F;
+        int color = dimensionColor;
+        float r = (float)(color >> 16 & 255) / 255F;
+        float g = (float)(color >> 8 & 255) / 255F;
+        float b = (float)(color & 255) / 255F;
         float f6 = getCurrentWeather() != null && getCurrentWeather().isPrecipitation ? weatherManager.getWeatherIntensity() * weatherManager.getWeatherPower() : 0.0f;
         if(f6 > 0.0F)
         {
-            float f7 = (f3 * 0.3F + f4 * 0.59F + f5 * 0.11F) * 0.6F;
+            float f7 = (r * 0.3F + g * 0.59F + b * 0.11F) * 0.6F;
             float f9 = 1.0F - f6 * 0.95F;
-            f3 = f3 * f9 + f7 * (1.0F - f9);
-            f4 = f4 * f9 + f7 * (1.0F - f9);
-            f5 = f5 * f9 + f7 * (1.0F - f9);
+            r = r * f9 + f7 * (1.0F - f9);
+            g = g * f9 + f7 * (1.0F - f9);
+            b = b * f9 + f7 * (1.0F - f9);
         }
-        f3 *= f2 * 0.9F + 0.1F;
-        f4 *= f2 * 0.9F + 0.1F;
-        f5 *= f2 * 0.85F + 0.15F;
-        return Vec3d.createVector(f3, f4, f5);
+        r *= f2 * 0.9F + 0.1F;
+        g *= f2 * 0.9F + 0.1F;
+        b *= f2 * 0.85F + 0.15F;
+        return Vec3d.createVector(r, g, b);
     }
 
-    public Vec3d getFogColor(double x, double y, double z, float partialTick)
+    public Vec3d getFogColor(ICamera camera, float partialTick)
     {
+    	double x = camera.getX(partialTick);
+    	double y = camera.getY(partialTick);
+    	double z = camera.getZ(partialTick);
         float celestialAngle = getCelestialAngle(partialTick);
         return worldType.getFogColor(this, x, y, z, celestialAngle, partialTick);
     }
@@ -2466,31 +2479,10 @@ public class World implements WorldSource {
         spawnPeacefulMobs = flag1;
     }
 
-    public void doLightingUpdate()
-    {
-        int i = worldType.getSkyDarken(this, getWorldTime(), 1.0F);
-        if(i != skyDarken)
-        {
-            skyDarken = i;
-            if(updateAllOnLightChange) {
-                for(int j = 0; j < listeners.size(); j++)
-                {
-                    ((LevelListener) listeners.get(j)).allChanged();
-                }	
-            }
-        }
-    }
-
-    public void doSeasonUpdate(boolean forceUpdate)
-    {
-        // Todo replace with better fix for frozen time spamming render updates then just checking the day cycle
-        if (getWorldTime() % DAY_LENGTH_TICKS == 0 && getGameRule(GameRules.DO_DAY_CYCLE) || forceUpdate)
-        {
-            for(int j = 0; j < listeners.size(); j++)
-            {
-                listeners.get(j).allChanged();
-            }
-        }
+    public void allChanged(boolean lightChanged, boolean seasonChanged) {
+		for(int i= 0; i < listeners.size(); i++) {
+            listeners.get(i).allChanged(lightChanged, seasonChanged);
+		}
     }
 
     protected void updateSleepingPlayers()
@@ -2512,35 +2504,52 @@ public class World implements WorldSource {
         }
     }
 
-    public void tick()
-    {
-        immediatelyUpdatedPositions.clear();
-        weatherManager.tick();
-        updateSleepingPlayers();
-        SpawnerMobs.performSpawning(this, spawnHostileMobs, spawnPeacefulMobs);
-        chunkProvider.tick();
-        doLightingUpdate();
-        long l1 = levelData.getWorldTime() + 1L;
-        int autosaveTimeInSeconds = Global.accessor.getAutosaveTimer();
+	public void tick() {
+		immediatelyUpdatedPositions.clear();
+		weatherManager.tick();
+		updateSleepingPlayers();
+		SpawnerMobs.performSpawning(this, spawnHostileMobs, spawnPeacefulMobs);
+		chunkProvider.tick();
 
-        int autosaveTimeInTicks = (autosaveTimeInSeconds * 20);
+		int autosaveTimeInSeconds = Global.accessor.getAutosaveTimer();
+		int autosaveTimeInTicks = (autosaveTimeInSeconds * 20);
 
-        AUTOSAVE = autosaveTimeInTicks != 0;
+		AUTOSAVE = autosaveTimeInTicks != 0;
+		if(AUTOSAVE && runtime % (long) autosaveTimeInTicks == 0L) {
+			saveWorld(false, null, true);
+		}
 
-        if (AUTOSAVE && runtime % (long)autosaveTimeInTicks == 0L)
-        {
-            saveWorld(false, null, true);
-        }
+		if(getGameRule(GameRules.DO_DAY_CYCLE)) {
+			levelData.setWorldTime(levelData.getWorldTime() + 1L);
+		}
 
-        if (getGameRule(GameRules.DO_DAY_CYCLE)){
-            levelData.setWorldTime(l1);
-        }
-        runtime++;
-        tickUpdates(false);
-        updateBlocksAndPlayCaveSounds();
+		runtime++;
 
-        doSeasonUpdate(false);
-    }
+		tickUpdates(false);
+		updateBlocksAndPlayCaveSounds();
+		updateSeasonAndLight();
+	}
+	
+	public void updateSeasonAndLight() {
+		boolean seasonChanged = false;
+		boolean lightChanged = false;
+
+		int currentDayCount = ((int) (levelData.getWorldTime() / Global.DAY_LENGTH_TICKS));
+		if(currentDayCount != dayCountLastTick) {
+			dayCountLastTick = currentDayCount;
+			seasonChanged = true;
+		}
+
+		int currentSkyDarken = worldType.getSkyDarken(this, getWorldTime(), 1.0f);
+		if(currentSkyDarken != skyDarken) {
+			skyDarken = currentSkyDarken;
+			lightChanged = true;
+		}
+
+		if(seasonChanged || lightChanged) {
+			allChanged(lightChanged, seasonChanged);
+		}
+	}
 
     protected void updateBlocksAndPlayCaveSounds()
     {
diff --git a/src/main/java/net/minecraft/core/world/biome/Biomes.java b/src/main/java/net/minecraft/core/world/biome/Biomes.java
index a33780a53..6df483bca 100644
--- a/src/main/java/net/minecraft/core/world/biome/Biomes.java
+++ b/src/main/java/net/minecraft/core/world/biome/Biomes.java
@@ -30,8 +30,6 @@ public class Biomes
     public static final Biome OVERWORLD_OUTBACK_GRASSY = register("minecraft:overworld.outback.grassy", new BiomeOutback("outback.grassy").setColor(0xf09037).setBlockedWeathers(Weather.overworldSnow).setTopBlock(Block.grassScorched.id).setFillerBlock(Block.dirtScorched.id));
     public static final Biome OVERWORLD_CAATINGA = register("minecraft:overworld.caatinga", new BiomeCaatinga("caatinga").setColor(0xdecda6).setTopBlock(Block.mudBaked.id).setFillerBlock(Block.mudBaked.id).setBlockedWeathers(Weather.overworldSnow));
     public static final Biome OVERWORLD_CAATINGA_PLAINS = register("minecraft:overworld.caatinga.plains", new Biome("caatinga.plains").setColor(0xa19477).setTopBlock(Block.mudBaked.id).setFillerBlock(Block.mudBaked.id).setBlockedWeathers(Weather.overworldSnow));
-    public static final Biome OVERWORLD_FOREST_DRY = register("minecraft:overworld.forest.dry", new BiomeForest("forest.dry").setColor(0x85c472));
-
     public static Biome register(String key, Biome biome)
     {
         Registries.BIOMES.register(key, biome);
diff --git a/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderOverworld.java b/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderOverworld.java
index af39067e0..a80c83e70 100644
--- a/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderOverworld.java
+++ b/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderOverworld.java
@@ -354,17 +354,13 @@ public final class BiomeProviderOverworld
                 new BiomeRange(0.3, 0.5, 0.0, 0.05, 0.0, 1.0, 0.0, 1.0)
         );
         brm.addRange(Biomes.OVERWORLD_BIRCH_FOREST,
-                new BiomeRange(0.5, 0.75, 0.2, 0.4, 0.0, 1.0, 0.0, 1.0)
+                new BiomeRange(0.5, 0.75, 0.3, 0.5, 0.0, 1.0, 0.0, 1.0)
         );
         brm.addRange(Biomes.OVERWORLD_SHRUBLAND,
-                new BiomeRange(0.5, 0.75, 0.05, 0.2, 0.0, 1.0, 0.0, 1.0)
+                new BiomeRange(0.5, 0.75, 0.05, 0.3, 0.0, 1.0, 0.0, 1.0)
         );
-        brm.addRange(Biomes.OVERWORLD_PLAINS,
-                new BiomeRange(0.75, 0.85, 0.1, 0.4, 0.0, 1.0, 0.0, 1.0)
-        );
-
         brm.addRange(Biomes.OVERWORLD_SEASONAL_FOREST,
-                new BiomeRange(0.5, 0.75, 0.4, 1.0, 0.0, 1.0, 0.0, 1.0)
+                new BiomeRange(0.5, 0.75, 0.5, 1.0, 0.0, 1.0, 0.0, 1.0)
         );
         brm.addRange(Biomes.OVERWORLD_SWAMPLAND,
                 new BiomeRange(0.75, 0.95, 0.85, 1.0, 0.0, 1.0, 0.0, 1.0)
diff --git a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
index c9de4489d..aa7f16875 100644
--- a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
+++ b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
@@ -235,8 +235,8 @@ public class ChunkDecoratorOverworld
         if (biome == Biomes.OVERWORLD_FOREST) {
             treeDensity += k4 + 5;
         }
-        if (biome == Biomes.OVERWORLD_FOREST_DRY) {
-            treeDensity += k4 + 1;
+        if (biome == Biomes.OVERWORLD_SHRUBLAND) {
+            treeDensity += k4 - 2;
         }
         if (biome == Biomes.OVERWORLD_BIRCH_FOREST) {
             treeDensity += k4 + 4;
@@ -321,6 +321,10 @@ public class ChunkDecoratorOverworld
         if (biome == Biomes.OVERWORLD_SHRUBLAND) {
             byteMeadow = 1;
         }
+        if (biome == Biomes.OVERWORLD_TAIGA) {
+            byteMeadow = 1;
+        }
+
         for (int l14 = 0; l14 < byteMeadow; l14++) {
             int blockId = Block.flowerPurple.id;
             if (rand.nextInt(12) == 0) {
@@ -361,12 +365,13 @@ public class ChunkDecoratorOverworld
         if (biome == Biomes.OVERWORLD_GRASSLANDS) {
             byteMarigold = 1;
         }
-        if (biome == Biomes.OVERWORLD_FOREST_DRY) {
-            byteMarigold = 1;
-        }
         if (biome == Biomes.OVERWORLD_PLAINS) {
             byteMarigold = 5;
         }
+
+        if (biome == Biomes.OVERWORLD_CAATINGA || biome == Biomes.OVERWORLD_CAATINGA_PLAINS) {
+            byteMarigold = 5;
+        }
         if (biome == Biomes.OVERWORLD_OUTBACK_GRASSY || biome == Biomes.OVERWORLD_OUTBACK) {
             byteMarigold = 3;
         }
@@ -416,9 +421,6 @@ public class ChunkDecoratorOverworld
         if (biome == Biomes.OVERWORLD_RAINFOREST) {
             byte1 = 10;
         }
-        if (biome == Biomes.OVERWORLD_DESERT) {
-            byte1 = 5;
-        }
         if (biome == Biomes.OVERWORLD_SEASONAL_FOREST) {
             byte1 = 2;
         }
@@ -428,8 +430,8 @@ public class ChunkDecoratorOverworld
         if (biome == Biomes.OVERWORLD_BOREAL_FOREST) {
             byte1 = 5;
         }
-        if (biome == Biomes.OVERWORLD_PLAINS) {
-            byte1 = 4;
+        if (biome == Biomes.OVERWORLD_GRASSLANDS) {
+            byte1 = 8;
         }
         if (biome == Biomes.OVERWORLD_CAATINGA) {
             byte1 = 2;
diff --git a/src/main/java/net/minecraft/core/world/season/Season.java b/src/main/java/net/minecraft/core/world/season/Season.java
index 7bac74345..a10430110 100644
--- a/src/main/java/net/minecraft/core/world/season/Season.java
+++ b/src/main/java/net/minecraft/core/world/season/Season.java
@@ -88,51 +88,4 @@ public abstract class Season
 		this.growFlowers = true;
 		return this;
 	}
-	
-	protected int getPeakGrassColorizer(int color)
-	{
-		return color;
-	}
-	
-	protected int getPeakFoliageColorizer(int color)
-	{
-		return color;
-	}
-	
-	public int modifyGrassColorizer(int color, Season otherSeason, float blendAmount)
-	{
-		int myColor = getPeakGrassColorizer(color);
-		int otherColor = otherSeason.getPeakGrassColorizer(color);
-		
-		return blendColors(myColor, otherColor, blendAmount);
-	}
-	
-	public int modifyFoliageColorizer(int color, Season otherSeason, float blendAmount)
-	{
-		int myColor = getPeakFoliageColorizer(color);
-		int otherColor = otherSeason.getPeakFoliageColorizer(color);
-		
-		return blendColors(myColor, otherColor, blendAmount);
-	}
-	
-	public static int blendColors(int colorA, int colorB, float blendAmount)
-	{
-		int rA = (colorA >> 16) & 0xFF;
-		int gA = (colorA >> 8) & 0xFF;
-		int bA = (colorA >> 0) & 0xFF;
-		
-		int rB = (colorB >> 16) & 0xFF;
-		int gB = (colorB >> 8) & 0xFF;
-		int bB = (colorB >> 0) & 0xFF;
-		
-		int dr = rB - rA;
-		int dg = gB - gA;
-		int db = bB - bA;
-		
-		int r = rA + (int)(dr * blendAmount);
-		int g = gA + (int)(dg * blendAmount);
-		int b = bA + (int)(db * blendAmount);
-		
-		return (r << 16) | (g << 8) | (b << 0);
-	}
 }
diff --git a/src/main/java/net/minecraft/core/world/season/SeasonFall.java b/src/main/java/net/minecraft/core/world/season/SeasonFall.java
index f7d39c706..75cf65d23 100644
--- a/src/main/java/net/minecraft/core/world/season/SeasonFall.java
+++ b/src/main/java/net/minecraft/core/world/season/SeasonFall.java
@@ -1,28 +1,8 @@
 package net.minecraft.core.world.season;
 
-import net.minecraft.client.render.colorizer.ColorProperties;
+public class SeasonFall extends Season {
 
-public class SeasonFall extends SeasonColorized
-{
-
-	public SeasonFall(String id)
-	{
-		super(id , true, false);
-	}
-
-	@Override
-	public int getPeakGrassColorizer(int color)
-	{
-		scp = ColorProperties.getSeasonColor("fall");
-
-		return super.getPeakGrassColorizer(color);
-	}
-	
-	@Override
-	public int getPeakFoliageColorizer(int color)
-	{
-		scp = ColorProperties.getSeasonColor("fall");
-
-		return super.getPeakFoliageColorizer(color);
+	public SeasonFall(String id) {
+		super(id, true, false);
 	}
 }
diff --git a/src/main/java/net/minecraft/core/world/season/SeasonOverworldHell.java b/src/main/java/net/minecraft/core/world/season/SeasonOverworldHell.java
index c79e1f40c..2fa8b1f94 100644
--- a/src/main/java/net/minecraft/core/world/season/SeasonOverworldHell.java
+++ b/src/main/java/net/minecraft/core/world/season/SeasonOverworldHell.java
@@ -1,21 +1,7 @@
 package net.minecraft.core.world.season;
 
-public class SeasonOverworldHell extends Season
-{
-	public SeasonOverworldHell(String id)
-	{
+public class SeasonOverworldHell extends Season {
+	public SeasonOverworldHell(String id) {
 		super(id);
 	}
-
-	@Override
-	public int getPeakGrassColorizer(int color)
-	{
-		return 0x7A6150;
-	}
-	
-	@Override
-	public int getPeakFoliageColorizer(int color)
-	{
-		return getPeakGrassColorizer(color);
-	}
 }
diff --git a/src/main/java/net/minecraft/core/world/season/SeasonParadiseGold.java b/src/main/java/net/minecraft/core/world/season/SeasonParadiseGold.java
index 32a33cd93..3bde361de 100644
--- a/src/main/java/net/minecraft/core/world/season/SeasonParadiseGold.java
+++ b/src/main/java/net/minecraft/core/world/season/SeasonParadiseGold.java
@@ -1,22 +1,7 @@
 package net.minecraft.core.world.season;
 
-public class SeasonParadiseGold extends SeasonColorized
-{
-
-	public SeasonParadiseGold(String id)
-	{
+public class SeasonParadiseGold extends Season {
+	public SeasonParadiseGold(String id) {
 		super(id, true, false);
 	}
-
-	@Override
-	public int getPeakGrassColorizer(int color)
-	{
-		return 0xFFFFAE00;
-	}
-	
-	@Override
-	public int getPeakFoliageColorizer(int color)
-	{
-		return 0xFFFFC700;
-	}
 }
diff --git a/src/main/java/net/minecraft/core/world/season/SeasonParadiseSilver.java b/src/main/java/net/minecraft/core/world/season/SeasonParadiseSilver.java
index cca5850ff..997ccd0f1 100644
--- a/src/main/java/net/minecraft/core/world/season/SeasonParadiseSilver.java
+++ b/src/main/java/net/minecraft/core/world/season/SeasonParadiseSilver.java
@@ -1,22 +1,7 @@
 package net.minecraft.core.world.season;
 
-public class SeasonParadiseSilver extends SeasonColorized
-{
-
-	public SeasonParadiseSilver(String id)
-	{
+public class SeasonParadiseSilver extends Season {
+	public SeasonParadiseSilver(String id) {
 		super(id, true, false);
 	}
-
-	@Override
-	public int getPeakGrassColorizer(int color)
-	{
-		return 0xFFDFDFFF;
-	}
-	
-	@Override
-	public int getPeakFoliageColorizer(int color)
-	{
-		return 0xFFDFDFFF;
-	}
 }
diff --git a/src/main/java/net/minecraft/core/world/season/SeasonSpring.java b/src/main/java/net/minecraft/core/world/season/SeasonSpring.java
index 9bcca800c..5317c65ed 100644
--- a/src/main/java/net/minecraft/core/world/season/SeasonSpring.java
+++ b/src/main/java/net/minecraft/core/world/season/SeasonSpring.java
@@ -1,28 +1,7 @@
 package net.minecraft.core.world.season;
 
-import net.minecraft.client.render.colorizer.ColorProperties;
-
-public class SeasonSpring extends SeasonColorized
-{
-
-	public SeasonSpring(String id)
-	{
+public class SeasonSpring extends Season {
+	public SeasonSpring(String id) {
 		super(id, false, false);
 	}
-
-	@Override
-	public int getPeakGrassColorizer(int color)
-	{
-		scp = ColorProperties.getSeasonColor("spring");
-
-		return super.getPeakGrassColorizer(color);
-	}
-
-	@Override
-	public int getPeakFoliageColorizer(int color)
-	{
-		scp = ColorProperties.getSeasonColor("spring");
-
-		return super.getPeakFoliageColorizer(color);
-	}
 }
diff --git a/src/main/java/net/minecraft/core/world/season/SeasonSummer.java b/src/main/java/net/minecraft/core/world/season/SeasonSummer.java
index 3f4d5f436..592c3bdf0 100644
--- a/src/main/java/net/minecraft/core/world/season/SeasonSummer.java
+++ b/src/main/java/net/minecraft/core/world/season/SeasonSummer.java
@@ -1,28 +1,7 @@
 package net.minecraft.core.world.season;
 
-import net.minecraft.client.render.colorizer.ColorProperties;
-
-public class SeasonSummer extends SeasonColorized
-{
-
-	public SeasonSummer(String id)
-	{
+public class SeasonSummer extends Season {
+	public SeasonSummer(String id) {
 		super(id, false, false);
 	}
-
-	@Override
-	public int getPeakGrassColorizer(int color)
-	{
-		scp = ColorProperties.getSeasonColor("summer");
-
-		return super.getPeakGrassColorizer(color);
-	}
-
-	@Override
-	public int getPeakFoliageColorizer(int color)
-	{
-		scp = ColorProperties.getSeasonColor("summer");
-
-		return super.getPeakFoliageColorizer(color);
-	}
 }
diff --git a/src/main/java/net/minecraft/core/world/season/SeasonWinter.java b/src/main/java/net/minecraft/core/world/season/SeasonWinter.java
index a54a48ffb..c7b960ec3 100644
--- a/src/main/java/net/minecraft/core/world/season/SeasonWinter.java
+++ b/src/main/java/net/minecraft/core/world/season/SeasonWinter.java
@@ -1,28 +1,7 @@
 package net.minecraft.core.world.season;
 
-import net.minecraft.client.render.colorizer.ColorProperties;
-
-public class SeasonWinter extends SeasonColorized
-{
-
-	public SeasonWinter(String id)
-	{
+public class SeasonWinter extends Season {
+	public SeasonWinter(String id) {
 		super(id, false, true);
 	}
-
-	@Override
-	public int getPeakGrassColorizer(int color)
-	{
-		scp = ColorProperties.getSeasonColor("winter");
-
-		return super.getPeakGrassColorizer(color);
-	}
-
-	@Override
-	public int getPeakFoliageColorizer(int color)
-	{
-		scp = ColorProperties.getSeasonColor("winter");
-
-		return super.getPeakFoliageColorizer(color);
-	}
 }
diff --git a/src/main/java/net/minecraft/core/world/season/Seasons.java b/src/main/java/net/minecraft/core/world/season/Seasons.java
index 3a2c3ac37..9d709c3eb 100644
--- a/src/main/java/net/minecraft/core/world/season/Seasons.java
+++ b/src/main/java/net/minecraft/core/world/season/Seasons.java
@@ -1,10 +1,12 @@
 package net.minecraft.core.world.season;
 
-import net.minecraft.core.world.weather.Weather;
-
+import java.util.ArrayList;
 import java.util.HashMap;
+import java.util.List;
 import java.util.Map;
 
+import net.minecraft.core.world.weather.Weather;
+
 public abstract class Seasons
 {
     private static final Map<String, Season> SEASONS_MAP = new HashMap<>();
@@ -34,4 +36,17 @@ public abstract class Seasons
 
         return season;
     }
+    
+    public static List<Season> getAllSeasons() {
+		List<String> seasonNames = new ArrayList<>(SEASONS_MAP.keySet());
+		seasonNames.sort(String.CASE_INSENSITIVE_ORDER);
+		
+		List<Season> seasons = new ArrayList<>();
+		
+		for(int i=0; i < seasonNames.size(); i++) {
+			seasons.add(getSeason(seasonNames.get(i)));
+		}
+		
+		return seasons;
+    }
 }
diff --git a/src/main/java/net/minecraft/core/world/type/WorldTypeOverworld.java b/src/main/java/net/minecraft/core/world/type/WorldTypeOverworld.java
index cd33c55da..bec4698d6 100644
--- a/src/main/java/net/minecraft/core/world/type/WorldTypeOverworld.java
+++ b/src/main/java/net/minecraft/core/world/type/WorldTypeOverworld.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.world.type;
 
+import net.minecraft.client.render.colorizer.Colorizers;
 import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.util.helper.MathHelper;
@@ -132,20 +133,27 @@ public abstract class WorldTypeOverworld
     public Vec3d getFogColor(World world, double x, double y, double z, float celestialAngle, float partialTick)
     {
         float dayProgress = MathHelper.cos(celestialAngle * MathHelper.PI * 2.0F) * 2.0F + 0.5F;
-        if(dayProgress < 0.0F)
-        {
-            dayProgress = 0.0F;
-        }
-        if(dayProgress > 1.0F)
-        {
-            dayProgress = 1.0F;
+        dayProgress = MathHelper.clamp(dayProgress, 0.0f, 1.0f);
+        float r, g, b;
+        
+        if(Colorizers.fog.isEnabled()) {
+        	int x1 = MathHelper.floor_double(x);
+        	int y1 = MathHelper.floor_double(y);
+        	int z1 = MathHelper.floor_double(z);
+        	
+        	int color = Colorizers.fog.getColor(world, x1, y1, z1);
+        	
+        	r = ((color >> 16) & 0xFF) / 255.0f;
+        	g = ((color >> 8) & 0xFF) / 255.0f;
+        	b = (color & 0xFF) / 255.0f;
+        }else {
+            r = 0.7529412f;
+            g = 0.8470588f;
+            b = 1.0f;
         }
-        float r = 0.7529412F;
-        float g = 0.8470588F;
-        float b = 1.0f;
-        r *= dayProgress * 0.94F + 0.06F;
-        g *= dayProgress * 0.94F + 0.06F;
-        b *= dayProgress * 0.91F + 0.09F;
+        r *= dayProgress * 0.94f + 0.06f;
+        g *= dayProgress * 0.94f + 0.06f;
+        b *= dayProgress * 0.91f + 0.09f;
         return Vec3d.createVector(r, g, b);
     }
 
diff --git a/src/main/java/net/minecraft/core/world/type/WorldTypeParadise.java b/src/main/java/net/minecraft/core/world/type/WorldTypeParadise.java
index 02892ea35..89d46b8f0 100644
--- a/src/main/java/net/minecraft/core/world/type/WorldTypeParadise.java
+++ b/src/main/java/net/minecraft/core/world/type/WorldTypeParadise.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.world.type;
 
+import net.minecraft.client.render.colorizer.Colorizers;
 import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.util.helper.MathHelper;
@@ -149,23 +150,30 @@ public abstract class WorldTypeParadise
     @Override
     public Vec3d getFogColor(World world, double x, double y, double z, float celestialAngle, float partialTick)
     {
-        int i = 0x8080a0;
         float f2 = MathHelper.cos(celestialAngle * 3.141593F * 2.0F) * 2.0F + 0.5F;
-        if(f2 < 0.0F)
-        {
-            f2 = 0.0F;
-        }
-        if(f2 > 1.0F)
-        {
-            f2 = 1.0F;
+        f2 = MathHelper.clamp(f2, 0.0f, 1.0f);
+        float r, g, b;
+        
+        if(Colorizers.fog.isEnabled()) {
+        	int x1 = MathHelper.floor_double(x);
+        	int y1 = MathHelper.floor_double(y);
+        	int z1 = MathHelper.floor_double(z);
+        	
+        	int color = Colorizers.fog.getColor(world, x1, y1, z1);
+        	
+        	r = ((color >> 16) & 0xFF) / 255.0f;
+        	g = ((color >> 8) & 0xFF) / 255.0f;
+        	b = (color & 0xFF) / 255.0f;
+        }else {
+            int i = 0x8080a0;
+            r = (float)(i >> 16 & 0xff) / 255.0f;
+            g = (float)(i >> 8 & 0xff) / 255.0f;
+            b = (float)(i & 0xff) / 255.0f;
         }
-        float f3 = (float)(i >> 16 & 0xff) / 255F;
-        float f4 = (float)(i >> 8 & 0xff) / 255F;
-        float f5 = (float)(i & 0xff) / 255F;
-        f3 *= f2 * 0.94F + 0.06F;
-        f4 *= f2 * 0.94F + 0.06F;
-        f5 *= f2 * 0.91F + 0.09F;
-        return Vec3d.createVector(f3, f4, f5);
+        r *= f2 * 0.94F + 0.06F;
+        g *= f2 * 0.94F + 0.06F;
+        b *= f2 * 0.91F + 0.09F;
+        return Vec3d.createVector(r, g, b);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/server/world/WorldManager.java b/src/main/java/net/minecraft/server/world/WorldManager.java
index eeada38d3..5cdcf0983 100644
--- a/src/main/java/net/minecraft/server/world/WorldManager.java
+++ b/src/main/java/net/minecraft/server/world/WorldManager.java
@@ -98,7 +98,7 @@ public class WorldManager
     }
 
     @Override
-	public void allChanged()
+	public void allChanged(boolean lightChanged, boolean seasonChanged)
     {
     }
 
